package com.zswl.cloud.springBtach.server.core.api.dfy;

import cn.hutool.http.HttpUtil;
import cn.hutool.json.JSONUtil;
import com.zswl.cloud.springBtach.server.core.api.dfy.request.DfyRequestBase;
import com.zswl.cloud.springBtach.server.core.api.dfy.request.ScenicRequest;
import com.zswl.cloud.springBtach.server.core.api.dfy.request.ScenicResponse;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

@Component
public class DiFengYunApi {

    @Value("${dfy.host}")
    private String host;

    @Value("${dfy.mp.secretkey}")
    private String secretKey;


    @Value("${dfy.mp.apikey}")
    private String apiKey;


    public ScenicResponse scenicList(ScenicRequest scenicRequest) {

        String post = post(scenicRequest, "/Ticket/scenicList");

        return JSONUtil.toBean(post, ScenicResponse.class);

    }


    private String post(DfyRequestBase dfyRequestBase, String url) {

        String signature = Signature.getSignature(JSONUtil.parseObj(dfyRequestBase), secretKey);
        dfyRequestBase.setSign(signature);
        dfyRequestBase.setApiKey(apiKey);

        String post = HttpUtil.post(host + url, JSONUtil.toJsonStr(dfyRequestBase));
        return post;

    }


}
